Make it possible for users to change to another cn in the D1Client class in d1_libclient_java module
Status: Closed Start date:  
Product Version: *   

Description

Member Nodes want to be able to choose which environment they will register in without shutting down to do so.  

In the D1Clieint class, there is a static class field CNode.  After the CNode was initialized, there is no way to change the CN:

public static CNode getCN(Session session) throws ServiceFailure {

if (cn == null) {

// get the CN URL

String cnUrl = Settings.getConfiguration().getString("D1Client.CN_URL");

        // determine which implementation to instantiate

        String cnClassName = Settings.getConfiguration().getString("D1Client.cnClassName");

        if (cnClassName != null) {

            // construct it using reflection

            try {

                cn = (CNode) Class.forName(cnClassName).newInstance();

            } catch (Exception e) {

                throw D1Node.recastClientSideExceptionToServiceFailure(e);

            }

            cn.setNodeBaseServiceUrl(cnUrl);

        } else {

            // default

            cn = new CNode(cnUrl, session);

        }

    }

    return cn;

}

Related issues:

Related to Infrastructure - Bug #7642: D1Client.getCN(Session s) method doesn... Closed 2016-02-12

History

#1 - 2014-04-30 00:22 - Ben Leinfelder

- Status changed from New to In Progress

- Assignee set to Ben Leinfelder

Added the method to D1Client. It uses the supplied cnURL and replaces the static CNode instance with one that uses the given url. Subsequent calls

to the parameter-less method will retrieve the CNode instance with the new URL.

#2 - 2014-05-02 19:17 - Ben Leinfelder

- Category set to d1_libclient_java

- Status changed from In Progress to Closed
#3 - 2014-06-20 17:25 - Rob Nahf

- Description updated

#4 - 2014-06-20 17:36 - Rob Nahf

- Description updated

#5 - 2016-02-12 21:25 - Rob Nahf

- Related to Bug #7642: D1Client.getCN(Session s) method doesn't use the session added
